<template>
  <div :key="id">
    <div class="container">
      <div
        id="masonry-container"
        class="row"
      >
        <div
          v-masonry
          fit-width="true"
          column-width="1"
          class="dimensions w-100"
        >
          <div
            v-for="({label, className, description, indicators}, identifier) in dimensionsAttributes"
            :key="identifier"
            class="dimension-item-wrapper p-1 col-12 col-sm-6 col-lg-4"
          >
            <router-link active-class="" :to="{ name: dimensionsType, params: {dimension: identifier} }">
              <dimensions-item
                v-masonry-tile
                :class="`dimension-item dimension-${className}`"
                :identifier="identifier"
                :indicator-values="getMetrics[identifier]"
                :indicators="indicators"
              >
                <template #title>
                  {{ $t(`message.dashboard.${identifier}.title`) }}
                </template>
                <template #score>
                  <span v-if="identifier === 'scoring'" class="total-score">
                    <!-- Treat the scoring card with special markup -->
                    <div class="mb-2">
                      <i
                        class="score-icon far"
                        :class="{
                          'fa-question-circle': evalTotalScoring() === -1,
                          'fa-times-circle': evalTotalScoring() === 0,
                          'fa-check-circle': evalTotalScoring() > 0,
                          'score--bad': evalTotalScoring() === 0,
                          'score--just-enough': evalTotalScoring() === 1,
                          'score--good': evalTotalScoring() === 2,
                          'score--excellent': evalTotalScoring() === 3,
                        }"
                      />
                    </div>
                    {{ getScore(identifier) }}
                  </span>
                  <span v-else>
                    {{ getScore(identifier) }}
                  </span>
                </template>
                <!-- Optional description content here -->
                <!-- {{ description }} -->
              </dimensions-item>
            </router-link>
          </div>
        </div>
      </div>
    </div>
    <!-- Modal window for displaying details view. See DimensionsDetailsModal -->
    <router-view />
  </div>
</template>

<script>
import { mapGetters, mapActions } from 'vuex'
import DimensionsItem from './DimensionsItem.vue'
import dimensionsAttributes from './utils/dimensions-attributes'

export default {
  name: 'Dimensions',
  components: {
    DimensionsItem
  },
  data () {
    return {
      id: this.$route.params.id,
      dimensionsAttributes
    }
  },
  props: {
    dimensionsType: {
      type: String,
      required: true,
      default () {
        return 'dimensions-details'
      }
    }
  },
  computed: {
    ...mapGetters([
      'metrics'
    ]),
    getMetrics () {
      return this.metrics
    }
  },
  created () {
    if (this.$route.params.dimension) {
      this.$modal.show('dimensions-details-modal')
    }
  },
  mounted () {
    this.loadMetrics()
    this.setup()
  },
  methods: {
    ...mapActions('globalModule', {
      loadGlobalMetrics: 'fetchMetrics'
    }),
    ...mapActions('catalogueModule', {
      loadCatalogueMetrics: 'fetchMetrics'
    }),
    ...mapActions('countryModule', {
      loadCountryMetrics: 'fetchMetrics'
    }),
    loadMetrics () {
      if (this.dimensionsType === 'dimensions-details') this.loadGlobalMetrics()
      else if (this.dimensionsType === 'catalogue-dimensions-details') this.loadCatalogueMetrics(this.id)
      else this.loadCountryMetrics(this.id)
    },
    async setup () {
      // Wait for a bit and then update the masonry layout
      // to prevent the layout from overlapping occassionally at initialization
      await this.sleep(950)
      this.$redrawVueMasonry()
    },
    sleep (ms) {
      return new Promise(resolve => setTimeout(resolve, ms))
    },
    evalTotalScoring () {
      if (this.getMetrics.score) {
        let score = Math.floor(this.getMetrics.score)
        return (score > 350) ? 3
          : (score > 220) ? 2
            : (score > 120) ? 1
              : 0
      } else return -1
    },
    getScore (identifier) {
      if (identifier === 'scoring' && this.getMetrics.score) {
        let score = this.evalTotalScoring()
        return (score === 3) ? this.$t('message.methodology.scoring.table.excellent')
          : ((score === 2) ? this.$t('message.methodology.scoring.table.good')
            : ((score === 1) ? this.$t('message.methodology.scoring.table.just_enough')
              : this.$t('message.methodology.scoring.table.bad')))
      } else return this.$t('message.no_data')
    }
  },
  watch: {
    'id': () => {
      this.loadMetrics()
    },
    getMetrics: function () {
      this.setup()
    }
  }
}
</script>

<style lang="scss" scoped>
@import "@/styles/metrics-style.scss";

@mixin gradient($colors...) {
  background-color: nth($colors, 1);
  background: -webkit-linear-gradient(left top, $colors);
  background: linear-gradient(to left top, $colors);
}

.dimension-accessibility {
  @include gradient($edp-logo-blue-gradient);
}

.dimension-findability {
  @include gradient($edp-logo-light-blue-gradient);
}

.dimension-interoperability {
  @include gradient($edp-logo-dark-blue-gradient);
}

.dimension-reusability {
  @include gradient($edp-logo-orange-gradient);
}

.dimension-contextual {
  @include gradient($edp-logo-yellow-gradient);
}

.dimension-total {
  background-color: $gray;
}

.dimension-scoring {
  background-image: $edp-logo-black-gradient;
}

.dimension-item {
  transition: width 2s, height 4s;
  .total-score {
    font-size: 1.1rem;
    font-weight: normal;
    .score-icon {
      font-size: 2.0rem;
    }
    .score {
      &--bad {
        color: #f67280;
      }
      &--just-enough {
        color: #f0cf85;
      }
      &--good {
        color: #a7e9af;
      }
      &--excellent {
        color: #b0deff;
      }
    }
  }
}

.dimension-score {
  background-image: linear-gradient(
    to right top,
    #71e0b9,
    #26c5c1,
    #00a8c2,
    #008ab8,
    #3b6aa0
  );
}
</style>
